import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class Main {
	
	public void uselessNonterminals(Flexer scanner) {
		int alphaLen = scanner.alphabet.returnSize();
		List<String> utils = new ArrayList<String>();
		int size1 = 0;
		int size2 = 0;
		while(size1 == size2) {
			for(int i = 0; i < alphaLen; i++) {
				if(scanner.rules.has(scanner.alphabet.returnElement(i))) {
					String aux = scanner.rules.returnValue(scanner.alphabet.returnElement(i));
					int count = 0;
					for(int j = 0; j < aux.length(); j++) {
						String ch = Character.toString(aux.charAt(j));
						if(ch.equals(ch.toLowerCase())){
							count++;
						}
					}
					if(count == aux.length()) {
						utils.add(aux);
						size1++;
					}
				}
			}
			if(size2 == size1) {
				break;
			}else{
				size2 = size1;
			}
		}
		for(int i = 0; i < scanner.nonterm.returnSize(); i++) {
			if(!utils.contains(scanner.nonterm.returnElement(i))) {
				System.out.println(scanner.nonterm.returnElement(i));
			}
		}
	}
	public void isVoid(Flexer scanner) {
		int alphaLen = scanner.alphabet.returnSize();
		List<String> utils = new ArrayList<String>();
		int size1 = 0;
		int size2 = 0;
		while(size1 == size2) {
			for(int i = 0; i < alphaLen; i++) {
				if(scanner.rules.has(scanner.alphabet.returnElement(i))) {
					String aux = scanner.rules.returnValue(scanner.alphabet.returnElement(i));
					int count = 0;
					for(int j = 0; j < aux.length(); j++) {
						String ch = Character.toString(aux.charAt(j));
						if(ch.equals(ch.toLowerCase())){
							count++;
						}
					}
					if(count == aux.length()) {
						utils.add(aux);
						size1++;
					}
				}
			}
			if(size2 == size1) {
				break;
			}else{
				size2 = size1;
			}
		}
		if(!utils.contains(scanner.firstState)) {
			System.out.println("Yes");
		}else {
			System.out.println("No");
		}
	}
	public void hasE(Flexer scanner) {
		int alphaLen = scanner.alphabet.returnSize();
		List<String> utils = new ArrayList<String>();
		int size1 = 0;
		int size2 = 0;
		while(size1 == size2) {
			for(int i = 0; i < alphaLen; i++) {
				if(scanner.rules.has(scanner.alphabet.returnElement(i))) {
					String aux = scanner.rules.returnValue(scanner.alphabet.returnElement(i));
					if(aux.equals("e")) {
						utils.add(scanner.alphabet.returnElement(i));
					}else {
						int count = 0;
						for(int j = 0; j < aux.length(); j++) {
							String ch = Character.toString(aux.charAt(j));
							if(ch.equals(ch.toUpperCase())) {
								if(utils.contains(ch)){
										count++;	
								}
							}
						}
						if(count == aux.length()) {
							utils.add(scanner.alphabet.returnElement(i));
						}
					}
					
				}
			}
			if(size2 == size1) {
				break;
			}else{
				size2 = size1;
			}
		}
		if(!utils.contains(scanner.firstState)) {
			System.out.println("Yes");
		}else {
			System.out.println("No");
		}
	}
	public boolean Semantic1(Flexer scanner) {
		int alphaLen = scanner.alphabet.returnSize();
		for(int i = 0; i < alphaLen; i++) {
			if(!scanner.nonterm.has(scanner.alphabet.returnElement(i))) {
				return false;
			}
		}
		return true;
	}
	public boolean Semantic2(Flexer scanner) {
		int notLen = scanner.nonterm.returnSize();
		for(int i = 0; i < notLen; i++) {
			if(!scanner.nonterm.returnElement(i).equals(scanner.nonterm.returnElement(i).toUpperCase())) {
				if(!scanner.alphabet.has(scanner.nonterm.returnElement(i))) {
					return false;
				}
			}
		}
		return true;
	}
	public boolean Semantic3(Flexer scanner) {
		if(!scanner.nonterm.has(scanner.firstState)) {
			return false;
		}
		return true;
	}
	public boolean Semantic4(Flexer scanner) {
		int len = scanner.alphabet.returnSize();
		for(int i = 0; i < len; i++) {
			if(scanner.rules.has(scanner.alphabet.returnElement(i))) {
				if(!scanner.nonterm.has(scanner.alphabet.returnElement(i)))
					return false;
			}
		}
		return true;
	}
	public boolean Semantic5(Flexer scanner) {
		int len = scanner.alphabet.returnSize();
		for(int i = 0; i < len; i++) {
			if(scanner.rules.has(scanner.alphabet.returnElement(i))) {
				String aux = scanner.rules.returnValue(scanner.alphabet.returnElement(i));
				for(int j = 0; j < aux.length(); j++) {
					String ch = Character.toString(aux.charAt(j));
					if(!scanner.nonterm.has(ch)){
						return false;
					}
				}
			}
		}
		return true;
	}
	
	
	public static void main(String[] args) {
		BufferedReader br;
		Main main = new Main();
		try {
			br = new BufferedReader(new FileReader("grammar"));
			Flexer scanner = new Flexer(br);
			scanner.yylex();
			if(args.length == 0 || (!args[0].equals("--is-void") && !args[0].equals("--has-e") && !args[0].equals("--useless-nonterminals"))){
				System.err.print("Argument error");
			}else if(scanner.syn == 1) {
				System.err.print("Syntax error");
			}else if(!main.Semantic1(scanner) || !main.Semantic2(scanner) || !main.Semantic3(scanner)
					|| !main.Semantic4(scanner) || !main.Semantic5(scanner)) {
				System.err.print("Semantic error");
			}else if(args[0].equals("--is-void")) {
				main.isVoid(scanner);
			}else if(args[0].equals("--has-e")) {
				main.hasE(scanner);
			}else if(args[0].equals("--useless-nonterminals")){
				main.uselessNonterminals(scanner);
			}

		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}	
	}

}
